## amzn-ena-aarch64-dkms-2.8.0-1-aarch64.pkg.tar.xz

=== src/amzn-drivers-2.8.0/ena/Makefile ===
ENA_COM_PATH=../common/ena_com/

obj-m += ena.o
ena-objs := ena_netdev.o \
		ena_ethtool.o \
		ena_lpc.o	\
		ena_phc.o \
		ena_xdp.o \
		dim.o \
		ena_devlink.o \
		net_dim.o \
		$(ENA_COM_PATH)/ena_com.o \
		$(ENA_COM_PATH)/ena_eth_com.o

ena-$(CONFIG_SYSFS) += ena_sysfs.o

ccflags-y := -I$(src)
ccflags-y += -I$(src)/$(ENA_COM_PATH)/


BUILD_KERNEL ?= $(shell uname -r)

ccflags-y += -Wfatal-errors

GENERATED_EXISTS := $(shell if [ -d include/generated ]; then echo True; fi)

ifneq ($(strip $(GENERATED_EXISTS)),)
  IS_UEK=$(shell grep uek include/generated/utsrelease.h)

  ifneq ($(strip $(IS_UEK)),)
    IS_3_8_13=$(shell grep -F 3.8.13 include/generated/utsrelease.h)

    ifneq ($(strip $(IS_3_8_13)),)
      ccflags-y += -DUEK3_RELEASE
    endif
  endif
endif

ifneq ("$(wildcard /etc/os-release)","")
  IS_DEBIAN=$(shell grep Debian /etc/os-release)

  ifneq ($(strip $(IS_DEBIAN)),)
    DEBIAN_VERSION_LINE=$(shell grep VERSION_ID /etc/os-release)
    REMOVE_QUOTES = $(subst $\",,$(DEBIAN_VERSION_LINE))
    REMOVE_EQUAL_SIGN = $(subst $\=,,$(REMOVE_QUOTES))
    DEBIAN_VERSION = $(subst VERSION_ID,,$(REMOVE_EQUAL_SIGN))
    ccflags-y += -DDEBIAN_VERSION=$(DEBIAN_VERSION)
  endif
endif

ifdef UBUNTU_ABI
	ccflags-y += -DUTS_UBUNTU_RELEASE_ABI=$(UBUNTU_ABI)
endif

ifdef TEST_AF_XDP
	ccflags-y += -DENA_TEST_AF_XDP
endif

ifdef ENA_PHC_INCLUDE
	ccflags-y += -DENA_PHC_INCLUDE
endif

all:
	$(MAKE) -C /lib/modules/$(BUILD_KERNEL)/build M=$(CURDIR) modules

clean:
	$(MAKE) -C /lib/modules/$(BUILD_KERNEL)/build M=$(CURDIR) clean

=== src/amzn-drivers-2.8.0/rpm/Makefile ===
# Makefile for creating a source rpm of the Amazon ENA driver
#
# Author: Cristian Gafton <gafton@amazon.com>

NAME	= ena
VERSION	= 2.8.0

TOPDIR	:= $(shell git rev-parse --show-toplevel)

TAG	= $(NAME)_linux_$(VERSION)
TARBALL	= $(NAME)-$(VERSION).tar

RPMDEFS = --define '_topdir  %(pwd)' \
	  --define '_ntopdir %(pwd)' \
	  --define '_builddir  %{_ntopdir}/build' \
	  --define '_buildrootdir %{_builddir}' \
	  --define '_sourcedir %{_ntopdir}' \
	  --define '_specdir   %{_ntopdir}' \
	  --define '_rpmdir    %{_ntopdir}' \
	  --define '_srcrpmdir %{_ntopdir}'

all : srpm

tarball : $(TARBALL)
$(TARBALL) : always
	(cd $(TOPDIR) && \
		git archive --format=tar --prefix=$(NAME)-$(VERSION)/ $(TAG) \
		kernel/linux/{common,ena}) > $@

srpm : $(TARBALL) Makefile
	rpmbuild -bs $(RPMDEFS) $(wildcard *.spec)

rpm : $(TARBALL) Makefile
	rpmbuild -ba $(RPMDEFS) $(wildcard *.spec)

clean :
	rm -f $(TARBALL) *.src.rpm

always :

.PHONY : srpm clean always

=== src/amzn-drivers-2.8.0/efa/rpm/Makefile ===
# Makefile for creating rpm of the Amazon EFA driver

NAME = efa
SPEC = $(NAME).spec
VERSION	= 1.16.0

TOPDIR  := $(shell git rev-parse --show-toplevel)
TAG	?= HEAD
TARBALL	= $(NAME)-$(VERSION).tar

RPMDEFS = --define '_topdir  %(pwd)' \
          --define '_ntopdir %(pwd)' \
          --define '_builddir  %{_ntopdir}/build' \
          --define '_buildrootdir %{_builddir}' \
          --define '_sourcedir %{_ntopdir}' \
          --define '_specdir   %{_ntopdir}' \
          --define '_rpmdir    %{_ntopdir}' \
          --define '_srcrpmdir %{_ntopdir}' \
	  --define "driver_version $(VERSION)"

all : rpm

tarball : $(TARBALL)
$(TARBALL) : always
	(cd $(TOPDIR) && \
	git archive --format=tar --prefix=$(NAME)-$(VERSION)/ $(TAG) \
	kernel/linux/efa/) > $@

srpm : $(TARBALL) Makefile
	rpmbuild -bs $(RPMDEFS) $(SPEC)

rpm : $(TARBALL) Makefile
	rpmbuild -ba $(RPMDEFS) $(SPEC)

clean :
	rm -f $(TARBALL) *.src.rpm

always:

.PHONY : srpm clean always

=== src/amzn-drivers-2.8.0/efa/debian/changelog ===
efa (1.16.0-1.amzn1) unstable; urgency=medium
  * Add CQ notifications
  * Add support for dmabuf
  * Add NeuronLink RDMA support
  * Remove gdr from module info keys

 -- Firas Jahjah <firasj@amazon.com>  Mon, 24 Jan 2022 16:03:29 +0000

efa (1.14.2-1.amzn1) unstable; urgency=medium
  * Various GDR fixes

 -- Firas Jahjah <firasj@amazon.com>  Sun, 17 Oct 2021 22:16:33 +0000

efa (1.14.1-1.amzn1) unstable; urgency=medium
  * Make gdr sysfs return zero in case nvidia symbols are not available

 -- Firas Jahjah <firasj@amazon.com>  Thu, 23 Sep 2021 15:27:31 +0000

efa (1.14.0-1.amzn1) unstable; urgency=medium
  * Unify the standard and GDR packages
  * Split hardware stats to device and port stats
  * Fix unfree'd IRQ vectors on error flow
  * Fix potential deadlock in GDR flow

 -- Gal Pressman <galpress@amazon.com>  Tue, 14 Sep 2021 09:49:22 +0000

efa (1.13.0-1.amzn1) unstable; urgency=medium
  * Remove static dependency of nvidia module in GDR driver
  * Fix potential memory leak in GDR memory registration error flow
  * Upstream kernel alignments
  * Remove old kernel APIs

 -- Gal Pressman <galpress@amazon.com>  Tue, 06 Jul 2021 14:31:39 +0000

efa (1.12.3-1.amzn1) unstable; urgency=medium
  * Fix potential NULL pointer dereference when using GDR on newer kernel version

 -- Gal Pressman <galpress@amazon.com>  Sun, 27 Jun 2021 11:03:33 +0000

efa (1.12.2-1.amzn1) unstable; urgency=medium
  * Fix mmap flow for applications compiled with EXEC permissions
  * Couple of packaging fixes

 -- Gal Pressman <galpress@amazon.com>  Wed, 16 Jun 2021 14:10:22 +0000

efa (1.12.1-1.amzn1) unstable; urgency=medium
  * Limit number of CMake processes to prevent exhaustion of system resources

 -- Gal Pressman <galpress@amazon.com>  Mon, 10 May 2021 11:09:31 +0000

efa (1.12.0-1.amzn1) unstable; urgency=medium
  * Add COPYING file
  * Switch to CMake build system
  * Align to upstream kernel

 -- Gal Pressman <galpress@amazon.com>  Mon, 29 Mar 2021 14:43:40 +0000

efa (1.11.1-1.amzn1) unstable; urgency=medium
  * Fix GDR driver packaging issues

 -- Gal Pressman <galpress@amazon.com>  Thu, 28 Jan 2021 09:59:26 +0000

efa (1.11.0-1.amzn1) unstable; urgency=medium
  * Fix wrong modify QP parameters
  * Align to upstream kernel changes

 -- Gal Pressman <galpress@amazon.com>  Sun, 06 Dec 2020 10:37:53 +0000

efa (1.10.2-1.amzn1) unstable; urgency=medium
  * Fix possible use of uninitialized variable in GDR error flow

 -- Gal Pressman <galpress@amazon.com>  Sun, 11 Oct 2020 16:38:54 +0000

efa (1.10.1-1.amzn1) unstable; urgency=medium
  * Misc fixes to GDR package installation
  * Expose messages and RDMA read statistics
  * Fix an error when registering MR on older kernels

 -- Gal Pressman <galpress@amazon.com>  Wed, 30 Sep 2020 14:42:44 +0000

efa (1.10.0-1.amzn1) unstable; urgency=medium
  * SRD RNR retry support
  * Remove a wrong warning triggered by GDR cleanup
  * Fix GDR driver compilation on Ubuntu 16.04
  * Add GDR driver packaging (rpm/deb)

 -- Gal Pressman <galpress@amazon.com>  Wed, 09 Sep 2020 17:52:09 +0000

efa (1.9.0-1.amzn1) unstable; urgency=medium
  * Adapt to upstream kernel
  * Refactor locking scheme in GDR flows
  * Report create CQ error counter
  * Report mmap error counter
  * Report admin commands error counter
  * Add a sysfs indication to GDR drivers
  * Add 0xefa1 device support

 -- Gal Pressman <galpress@amazon.com>  Mon, 03 Aug 2020 14:00:03 +0000

efa (1.6.0-1.amzn1) unstable; urgency=medium
  * Add NVIDIA GPUDirect RDMA support
  * Add a configure script to the compilation process and use it to test for
    kernel functionality
  * Change directory structure, the source files are now located under src/
  * Fix compilation on certain kernels of SuSE15.1
  * Backport changes from upstream kernel

 -- Gal Pressman <galpress@amazon.com>  Wed, 26 Feb 2020 14:54:52 +0000

efa (1.5.1-1.amzn1) unstable; urgency=medium
  * Fix SuSE ioctl flow backport

 -- Gal Pressman <galpress@amazon.com>  Thu, 02 Jan 2020 16:21:54 +0000

efa (1.5.0-1.amzn1) unstable; urgency=medium
  * RDMA read support
  * Make ib_uverbs a soft dependency
  * Fix ioctl flows on older kernels
  * SuSE 15.1 support

 -- Gal Pressman <galpress@amazon.com>  Wed, 11 Dec 2019 13:18:56 +0000

efa (1.4.1-1.amzn1) unstable; urgency=medium
  * Fix Incorrect error print
  * Add support for CentOS 7.7

 -- Gal Pressman <galpress@amazon.com>  Fri, 20 Sep 2019 18:57:58 +0000

efa (1.4.0-1.amzn1) unstable; urgency=medium

  * Expose device statistics
  * Rate limit admin queue error prints
  * Properly assign err variable on everbs device creation failure

 -- Gal Pressman <galpress@amazon.com>  Thu, 5 Sep 2019 16:31:33 +0000

efa (1.3.1-1.amzn1) unstable; urgency=medium

  * Fix build issue in debian/rules file
  * Fix kcompat issue (usage before include)

 -- Gal Pressman <galpress@amazon.com>  Thu, 8 Aug 2019 11:19:27 +0000

efa (1.3.0-1.amzn1) unstable; urgency=medium

  * Align to the driver that was merged upstream
  * Fix a bug where failed functions would return success return value
  * Fix modify QP udata check backport
  * Fix locking issues in mmap flow
  * Add Debian packaging files

 -- Gal Pressman <galpress@amazon.com>  Sun, 7 Jul 2019 15:05:27 +0000

efa (0.9.2-1.amzn1) unstable; urgency=medium

  * Initial release of EFA kernel driver Debian package

 -- Jie Zhang <zhngaj@amazon.com>  Wed, 22 May 2019 23:03:27 +0000

=== src/amzn-drivers-2.8.0/efa/debian/control ===
Source: efa
Maintainer: ec2-efa-maintainers <ec2-efa-maintainers@amazon.com>
Build-Depends: debhelper
Standards-Version: 4.3.0
Homepage: https://github.com/amzn/amzn-drivers

Package: efa
Architecture: any
# Replace the compile time dependency efa-gdr package
Provides: efa-gdr
Conflicts: efa-gdr
Replaces: efa-gdr
Depends: ${shlibs:Depends}, ${misc:Depends}, dkms, cmake
Description: Linux kernel driver for Elastic Fabric Adapter (EFA)
 Elastic Fabric Adapter (EFA), a new network device that provides reliable
 userspace communication and kernel bypass capabilities, targeting more
 consistent latency and higher throughput.

=== src/amzn-drivers-2.8.0/efa/debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

NAME	= efa
VERSION = 1.16.0
DESTDIR:=`pwd`/debian/${NAME}
INSTALL_PATH = /usr/src/${NAME}-${VERSION}


%:
	dh $@

override_dh_auto_clean:
	dh_clean

override_dh_auto_build:
	echo "Skip build"

override_dh_auto_configure:
	echo "Skip configure"

override_dh_auto_install:
	mkdir -p ${DESTDIR}/${INSTALL_PATH}
	mkdir -p ${DESTDIR}/${INSTALL_PATH}/config
	mkdir -p ${DESTDIR}/${INSTALL_PATH}/src
	install -D -m 644 conf/efa.conf		${DESTDIR}/etc/modules-load.d/efa.conf
	install -D -m 644 conf/efa-modprobe.conf ${DESTDIR}/etc/modprobe.d/efa.conf
	install -m 644 conf/dkms.conf		${DESTDIR}/${INSTALL_PATH}
	install -m 744 conf/configure-dkms.sh	${DESTDIR}/${INSTALL_PATH}
	install -m 644 src/efa_com.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_com_cmd.c	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_main.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_sysfs.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_verbs.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa-abi.h 		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_admin_cmds_defs.h ${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_admin_defs.h 	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_com_cmd.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_com.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_common_defs.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_io_defs.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_regs_defs.h	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_sysfs.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/kcompat.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/CMakeLists.txt	${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/Kbuild.in		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_p2p.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_p2p.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_gdr.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/nv-p2p.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/efa_neuron.c		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 src/neuron_p2p.h		${DESTDIR}/${INSTALL_PATH}/src
	install -m 644 README			${DESTDIR}/${INSTALL_PATH}
	install -m 644 RELEASENOTES.md		${DESTDIR}/${INSTALL_PATH}
	install -m 644 CMakeLists.txt		${DESTDIR}/${INSTALL_PATH}
	install -m 644 config/Makefile		${DESTDIR}/${INSTALL_PATH}/config
	install -m 644 config/main.c.in		${DESTDIR}/${INSTALL_PATH}/config
	install -m 744 config/compile_conftest.sh	${DESTDIR}/${INSTALL_PATH}/config
	install -m 744 config/wait_for_pid.sh	${DESTDIR}/${INSTALL_PATH}/config
	install -m 644 config/efa.cmake		${DESTDIR}/${INSTALL_PATH}/config
	install -m 744 config/runbg.sh		${DESTDIR}/${INSTALL_PATH}/config
